/* $Id: config.h 81 2023-05-13 05:45:19Z nishi $ */
#ifndef __SWINEHUB_CONFIG_H__
#define __SWINEHUB_CONFIG_H__

#ifndef SWINEHUB_DEFAULT_SERVER
#define SWINEHUB_DEFAULT_SERVER		"127.0.0.1"
#endif

#ifndef SWINEHUB_DEFAULT_PORT
#define SWINEHUB_DEFAULT_PORT		80
#endif

#ifndef SWINEHUB_DEFAULT_PREFIX
#define SWINEHUB_DEFAULT_PREFIX		"/svn"
#endif

#ifndef SWINEHUB_DEFAULT_PATH
#define SWINEHUB_DEFAULT_PATH		"/var/svn"
#endif

#ifndef SWINEHUB_DEFAULT_CACHEPATH
#define SWINEHUB_DEFAULT_CACHEPATH	"/var/svn-cache"
#endif

#ifndef SWINEHUB_DEFAULT_CSSPATH
#define SWINEHUB_DEFAULT_CSSPATH	"/style.css"
#endif

#ifndef SWINEHUB_DEFAULT_ICONPATH
#define SWINEHUB_DEFAULT_ICONPATH	"/icon.png"
#endif

#ifndef SWINEHUB_DEFAULT_ITWORKS
#define SWINEHUB_DEFAULT_ITWORKS	1
#endif

#ifndef SWINEHUB_DEFAULT_SCRIPTPATH
#define SWINEHUB_DEFAULT_SCRIPTPATH	"/script.js"
#endif

#ifndef SWINEHUB_DEFAULT_SVN
#define SWINEHUB_DEFAULT_SVN		"/usr/pkg/bin/svn"
#endif

#ifndef SWINEHUB_DEFAULT_SVNADMIN
#define SWINEHUB_DEFAULT_SVNADMIN	"/usr/pkg/bin/svnadmin"
#endif

#ifndef SWINEHUB_DEFAULT_HTPASSWD
#define SWINEHUB_DEFAULT_HTPASSWD	"/usr/pkg/bin/htpasswd"
#endif

#ifndef SWINEHUB_DEFAULT_SIGNUP
#define SWINEHUB_DEFAULT_SIGNUP		0
#endif

#ifndef SWINEHUB_DEFAULT_TITLE
#define SWINEHUB_DEFAULT_TITLE		"SwineHub"
#endif

struct swinehub_config {
	char* server;
	int port;
	char itworks;
	char* prefix;
	char* path;
	char* csspath;
	char* iconpath;
	char* scriptpath;
	char* cachepath;
	char* svn;
	char* svnadmin;
	char* htpasswd;
	int signup;
	char* title;
	char* url_prefix;
};

struct swinehub_config* swinehub_parse_config(const char* path);
void swinehub_free_config(struct swinehub_config* config);

#endif
