/* $Id: db.c 54 2023-05-03 03:12:52Z nishi $ */
#include <swinehub/db.h>

#include <swinehub.h>

#include <fcntl.h>
#include <sys/stat.h>
#include <errno.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

DBM* swinehub_token_db = NULL;
DBM* swinehub_user_db = NULL;

int swinehub_db_init(){
	if(swinehub_token_db != NULL){
		dbm_close(swinehub_token_db);
		swinehub_token_db = NULL;
	}
	if(swinehub_user_db != NULL){
		dbm_close(swinehub_user_db);
		swinehub_user_db = NULL;
	}
retry_db:
	if(swinehub_token_db == NULL){
		swinehub_token_db = dbm_open(
			SWINEHUB_TOKEN_DB,
			O_RDWR | O_CREAT,
			S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH
		);
	}
	if(swinehub_user_db == NULL){
		swinehub_user_db = dbm_open(
			SWINEHUB_USER_DB,
			O_RDWR | O_CREAT,
			S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH
		);
	}
	if(swinehub_token_db == NULL || swinehub_user_db == NULL){
		usleep(100000);
		goto retry_db;
	}
	return 0;
}
